class ContractsController < ApplicationController
  before_action :check_auth
  before_action :set_contract, only: [:show, :destroy]

  def index
    @contracts = @current_user.contracts
  end

  def show
  end

  def destroy
    if @contract.destroy
      flash[:notice] = 'Contract deleted'
    else
      flash[:alert] = 'Couldn\'t delete the contract'
    end
    redirect_to contracts_url
  end

  private

  def set_contract
    @contract = @current_user.contracts.where(id: params[:id]).first!
  end
end