class Decide::Acsmi::Contracting::Api::V1::SessionsController < Decide::Acsmi::Contracting::Api::V1::ApiController
  before_action :set_session, only: [:credentials]

  def create
    begin
      @session = Session.start_for(params[:resource_id])
      render json: { session_id: @session.id, contracting_url: sessions_url(session_id: @session.id) }
    rescue => e
      return error_response("Could not start session: #{e.message}")
    end
  end

  def credentials
    return error_response('Session contract is not yet set') unless @session.ready?

    render json: @session.cred_response
  end

  private

  def set_session
    @session = Session.find_by_id(params[:id])
    return error_response("Could not find session with ID #{params[:id]}", 404) unless @session
  end

end