class UserSessionsController < ApplicationController
  def new
    @user_session = UserSession.new
  end

  def create
    if params[:session_id] && params[:have_account]
      create_multiform
    elsif params[:sign_in]
      create_signle
    else
      redirect_to '/'
      flash[:alert] = 'Couldn\'t sign in'
    end
  end

  def destroy
    current_user_session.destroy
    redirect_to '#'
  end

  private

  def create_multiform
    @session = Session.find(params[:session_id])
    @have_account = params[:have_account] == 'true'
    if @have_account
      @user = User.new
      @user_session = UserSession.new(user_session_params)
      save_object(@user_session)
    else
      @user_session = UserSession.new
      @user = User.new(user_params)
      save_object(@user)
    end
  end

  def create_signle
    @user_session = UserSession.new(user_session_params)
    if @user_session.save
      redirect_to contracts_url
    else
      render :new
    end
  end

  def save_object(object)
    if object.save
      @session.update(user: current_user)
      redirect_to setup_contracting_session_path(@session)
    else
      render template: 'sessions/start_contracting'
    end
  end

  def user_session_params
    params.require(:user_session).permit(:email, :password)
  end

  def user_params
    params.require(:user).permit(:email, :full_name, :password, :password_confirmation, :organization, :address, :accept_terms)
  end
end