class Contract < ActiveRecord::Base
  belongs_to :user
  has_many :sessions

  validates :resource_id, presence: true
  validates :resource_name, presence: true
  validates :user, presence: true

  def self.prepare(session)
    session.user.register_plaform_user if session.user.platform_email.blank?
    PlatformConnector.register_access(session.resource_id, session.user.platform_id)

    session.contract = Contract.create!(user: session.user, resource_id: session.resource_id, resource_name: session.resource_name)
    session.save!
  end
end