class User < ActiveRecord::Base
  has_many :contracts, dependent: :destroy
  has_many :sessions, dependent: :destroy

  acts_as_authentic

  attr_accessor :accept_terms

  validates :email, presence: true, uniqueness: true
  validates :full_name, presence: true
  validate :usage_terms_accepted, on: :create

  attr_encrypted :platform_email, key: "211aae60391b4152ad4690ce4aa89d8c"
  attr_encrypted :platform_password, key: "2694536f973b4e5faab7e4f6e8e4d427"

  def register_plaform_user
    self.platform_email = "acsmi-#{SecureRandom.hex(10)}@cloudbroker.com"
    self.platform_password = SecureRandom.hex(12)

    first_name = self.full_name.split(' ')[0]
    last_name = self.full_name.split(' ')[1] || 'undefined'

    self.platform_id = PlatformConnector.register_user(self.platform_email, first_name, last_name, self.platform_password)
    self.save!
  end

  private

  def usage_terms_accepted
    unless self.accept_terms == '1'
      self.errors.add(:base, 'You must accept usage terms in order to sign up')
    end
  end
end
