/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A Service.
 */
@Entity
@Table(name = "service")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class Service extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Size(max = 70)
    @Column(name = "servicename", length = 70, nullable = false)
    private String servicename;    

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    /*
    @OneToMany(mappedBy = "service", fetch = FetchType.LAZY, cascade = CascadeType.ALL)
    @JsonIgnoreProperties({"service"})
    @Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
    private Set<ServiceInstance> serviceinstances = new HashSet<>();
    */
    
    @ManyToOne(cascade = CascadeType.MERGE)
    private ServiceClass serviceclass;
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getServicename() {
        return servicename;
    }

    public Service servicename(String servicename) {
        this.servicename = servicename;
        return this;
    }

    public void setServicename(String servicename) {
        this.servicename = servicename;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public Service deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }
    
    
    /*
    public Set<ServiceInstance> getServiceinstances() {
        return serviceinstances;
    }

    public Service serviceinstances(Set<ServiceInstance> serviceinstances) {
        this.serviceinstances = serviceinstances;
        return this;
    }

    public Service addServiceInstance(ServiceInstance serviceinstance) {
        this.serviceinstances.add(serviceinstance);
        serviceinstance.setService(this);
        return this;
    }

    public Service removeServiceInstance(ServiceInstance serviceinstance) {
        this.serviceinstances.remove(serviceinstance);
        serviceinstance.setService(null);
        return this;
    }

    public void setServiceinstances(Set<ServiceInstance> serviceinstances) {
        this.serviceinstances = serviceinstances;
    }
    */
    
    public ServiceClass getServiceclass() {
        return serviceclass;
    }

    public Service serviceclass(ServiceClass serviceclass) {
        this.serviceclass = serviceclass;
        return this;
    }

    public void setServiceclass(ServiceClass serviceclass) {
        this.serviceclass = serviceclass;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        Service service = (Service) o;
        if (service.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), service.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "Service{" +
            "id=" + getId() +
            ", servicename='" + getServicename() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            "}";
    }
}
