/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A Service.
 */
@Entity
@Table(name = "service_attribute_type")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class ServiceAttributeType extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Size(max = 50)
    @Column(name = "serviceattributetypename", length = 50, nullable = false)
    private String serviceattributetypename;
    
    @NotNull
    @Size(max = 50)
    @Column(name = "datatype", length = 50, nullable = false)
    private String datatype;
    
    @NotNull
    @Column(name = "mandatoryenumeration", nullable = false)
    private Boolean mandatoryenumeration;
    
    @Column(name = "enumerationvalues", nullable = true)
    private String enumerationvalues;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getServiceattributetypename() {
        return serviceattributetypename;
    }

    public ServiceAttributeType serviceattributetypename(String serviceattributetypename) {
        this.serviceattributetypename = serviceattributetypename;
        return this;
    }

    public void setServiceattributetypename(String serviceattributetypename) {
        this.serviceattributetypename = serviceattributetypename;
    }
    
    public String getDatatype() {
        return datatype;
    }

    public ServiceAttributeType datatype(String datatype) {
        this.datatype = datatype;
        return this;
    }

    public void setDatatype(String datatype) {
        this.datatype = datatype;
    }
    
    public boolean isMandatoryenumeration() {
        return mandatoryenumeration;
    }

    public ServiceAttributeType mandatoryenumeration(boolean mandatoryenumeration) {
        this.mandatoryenumeration = mandatoryenumeration;
        return this;
    }

    public void setMandatoryenumeration(boolean mandatoryenumeration) {
        this.mandatoryenumeration = mandatoryenumeration;
    }
    
    public String getEnumerationvalues() {
        return enumerationvalues;
    }

    public ServiceAttributeType enumerationvalues(String enumerationvalues) {
        this.enumerationvalues = enumerationvalues;
        return this;
    }

    public void setEnumerationvalues(String enumerationvalues) {
        this.enumerationvalues = enumerationvalues;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServiceAttributeType deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceAttributeType serviceAttributeType = (ServiceAttributeType) o;
        if (serviceAttributeType.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceAttributeType.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "Service{" +
            "id=" + getId() +
            ", serviceattributetypename='" + getServiceattributetypename() + "'" +
            ", datatype='" + getDatatype() + "'" +
            ", mandatoryenumeration='" + isMandatoryenumeration() + "'" +
            ", enumerationvalues='" + getEnumerationvalues() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            "}";
    }
}
