/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

/**
 * A ServiceClassTypicalAttribute.
 */
@Entity
@Table(name = "service_class_typical_attribute")
@Cache(usage = CacheConcurrencyStrategy.NONSTRICT_READ_WRITE)
public class ServiceClassTypicalAttribute extends AbstractAuditingEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Column(name = "weight", nullable = false)
    private Integer weight;
    
    @NotNull
    @Column(name = "mandatory", nullable = false)
    private Boolean mandatory;

    @Column(name = "deleted_date")
    private ZonedDateTime deleteddate;
    
    @NotNull
    @Column(name = "serviceclass_id", nullable = false)
    private Long serviceclassid;
    
    @NotNull
    @Column(name = "serviceattributetype_id", nullable = false)
    private Long serviceattributetypeid;
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    public Integer getWeight() {
        return weight;
    }

    public ServiceClassTypicalAttribute weight(Integer weight) {
        this.weight = weight;
        return this;
    }

    public void setWeight(Integer weight) {
        this.weight = weight;
    }
    
    public boolean isMandatory() {
        return mandatory;
    }

    public ServiceClassTypicalAttribute mandatory(boolean mandatory) {
        this.mandatory = mandatory;
        return this;
    }

    public void setMandatory(boolean mandatory) {
        this.mandatory = mandatory;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServiceClassTypicalAttribute deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }
    
    public Long getServiceclassid() {
        return serviceclassid;
    }

    public ServiceClassTypicalAttribute serviceclassid(Long serviceclassid) {
        this.serviceclassid = serviceclassid;
        return this;
    }

    public void setServiceclassid(Long serviceclassid) {
        this.serviceclassid = serviceclassid;
    }
    
    public Long getServiceattributetypeid() {
        return serviceattributetypeid;
    }

    public ServiceClassTypicalAttribute serviceattributetypeid(Long serviceattributetypeid) {
        this.serviceattributetypeid = serviceattributetypeid;
        return this;
    }

    public void setServiceattributetypeid(Long serviceattributetypeid) {
        this.serviceattributetypeid = serviceattributetypeid;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceClassTypicalAttribute serviceClassTypicalAttribute = (ServiceClassTypicalAttribute) o;
        if (serviceClassTypicalAttribute.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), serviceClassTypicalAttribute.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "ServiceClassTypicalAttribute{" +
            "id=" + getId() +
            ", weight='" + getWeight() + "'" +
            ", mandatory='" + isMandatory() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            ", serviceclassid='" + getServiceclassid() + "'" +
            ", serviceattributetypeid='" + getServiceattributetypeid() + "'" +
            "}";
    }
}
