/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.Objects;

/**
 * A ServiceAttributeVO.
 */
public class ServiceAttributeVO implements Serializable, Comparable<ServiceAttributeVO> {

    private static final long serialVersionUID = 1L;
    
    private Long serviceid;
    
    private Long attributetypeid;
    
    private String attributetypevalue;
    
    
    public ServiceAttributeVO() {
    	this.serviceid = null;
    	this.attributetypeid = null;
    	this.attributetypevalue = null;
    }
    		
    public ServiceAttributeVO(Long serviceid, Long attributetypeid, String attributetypevalue) {
    	this.serviceid = serviceid;
    	this.attributetypeid = attributetypeid;
    	this.attributetypevalue = attributetypevalue;
    }
    
    
    public Long getServiceid() {
        return serviceid;
    }

    public void setServiceid(final Long serviceid) {
        this.serviceid = serviceid;
    }
    
    public Long getAttributetypeid() {
        return attributetypeid;
    }

    public void setAttributetypeid(final Long attributetypeid) {
        this.attributetypeid = attributetypeid;
    }

    public String getAttributetypevalue() {
        return attributetypevalue;
    }
   
    public void setAttributetypevalue(final String attributetypevalue) {
        this.attributetypevalue = attributetypevalue;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceAttributeVO serviceAttributeVO = (ServiceAttributeVO) o;
        if (serviceAttributeVO.getServiceid() == null || getServiceid() == null) {
            return false;
        }
        return Objects.equals(getServiceid(), serviceAttributeVO.getServiceid());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getServiceid());
    }

    @Override
    public String toString() {
    	return "ServiceAttributeVO{" +
                "serviceid='" + getServiceid() + "'" +
                ", attributetypeid='" + getAttributetypeid() + "'" +
                ", attributetypevalue='" + getAttributetypevalue() + "'" +
                "}";
    }
    
    public int compareTo(ServiceAttributeVO vo) {
    	return this.getServiceid().compareTo(vo.getServiceid());
    }
}
