/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * A ServiceFilterVO.
 */
public class ServiceFilterVO implements Serializable {

    private static final long serialVersionUID = 1L;
    
    // Propiedades de entrada
    private Long classid;
    
    private List<Long> attributetypeids;
    
    private List<String> attributetypevalues;

    // Propiedades de salida
    private Long serviceid;

    private String servicename;
    
    private Long valueid;
    
    private String value;
    
    private Long typeid;
    
    private String type;
    
    private String enumeration;
    
    
    public ServiceFilterVO() {
    	this.classid = null;
    	this.attributetypeids = new ArrayList<Long>();
    	this.attributetypevalues = new ArrayList<String>();
    	
    	this.serviceid = null;
    	this.servicename = null;
    	this.valueid = null;
    	this.value = null;
    	this.typeid = null;
    	this.type = null;
    	this.enumeration = null;
    }
    
    public ServiceFilterVO(Long classid) {
    	this.classid = classid;
    	this.attributetypeids = new ArrayList<Long>();
    	this.attributetypevalues = new ArrayList<String>();
    	
    	this.serviceid = null;
    	this.servicename = null;
    	this.valueid = null;
    	this.value = null;
    	this.typeid = null;
    	this.type = null;
    	this.enumeration = null;
    }
    		
    public ServiceFilterVO(Long serviceid, String servicename, Long valueid, String value,
    		Long typeid, String type, String enumeration) {
    	this.classid = null;
    	this.attributetypeids = new ArrayList<Long>();
    	this.attributetypevalues = new ArrayList<String>();
    	
    	this.serviceid = serviceid;
    	this.servicename = servicename;
    	this.valueid = valueid;
    	this.value = value;
    	this.typeid = typeid;
    	this.type = type;
    	this.enumeration = enumeration;
    }
    
    
    public Long getClassid() {
        return classid;
    }

    public void setClassid(final Long classid) {
        this.classid = classid;
    }
    
    public List<Long> getAttributetypeids() {
    	return attributetypeids;
    }
    
    public void setAttributeTypeids(final List<Long> attributetypeids) {
    	this.attributetypeids = attributetypeids;
    }
    
    public List<String> getAttributetypevalues() {
    	return attributetypevalues;
    }
    
    public void setAttributeTypevalues(final List<String> attributetypevalues) {
    	this.attributetypevalues = attributetypevalues;
    }
    
    public Long getServiceid() {
        return serviceid;
    }

    public void setServiceid(final Long serviceid) {
        this.serviceid = serviceid;
    }

    public String getServicename() {
        return servicename;
    }
   
    public void setServicename(final String servicename) {
        this.servicename = servicename;
    }
    
    public Long getValueid() {
        return valueid;
    }

    public void setValueid(final Long valueid) {
        this.valueid = valueid;
    }
    
    public String getValue() {
        return value;
    }

    public void setValue(final String value) {
        this.value = value;
    }
    
    public Long getTypeid() {
        return typeid;
    }

    public void setTypeid(final Long typeid) {
        this.typeid = typeid;
    }
    
    public String getType() {
        return type;
    }

    public void setType(final String type) {
        this.type = type;
    }
    
    public String getEnumeration() {
        return enumeration;
    }

    public void setEnumeration(final String enumeration) {
        this.enumeration = enumeration;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServiceFilterVO serviceFilterVO = (ServiceFilterVO) o;
        if (serviceFilterVO.getServiceid() == null || getServiceid() == null) {
            return false;
        }
        return Objects.equals(getServiceid(), serviceFilterVO.getServiceid());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getServiceid());
    }

    @Override
    public String toString() {
    	StringBuffer ret = new StringBuffer();
    	ret.append("ServiceFilterVO{");
    	ret.append("classid=").append(getClassid());
    	ret.append(", attributetypeids=[");
    	for (Long l : attributetypeids) {
    		ret.append(l).append(",");
    	}
    	ret.append("]");
    	ret.append(", attributetypevalues=[");
    	for (String s : attributetypevalues) {
    		ret.append(s).append(",");
    	}
    	ret.append("]");
    	ret.append(", serviceid=").append(getServiceid());
    	ret.append(", servicename=").append(getServicename());
    	ret.append(", valueid=").append(getValueid());
    	ret.append(", value=").append(getValue());
    	ret.append(", typeid=").append(getTypeid());
    	ret.append(", type=").append(getType());
    	ret.append(", enumeration=").append(getEnumeration());
    	ret.append("}");

    	return ret.toString();
    }
}
