/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.domain.vo;

import java.io.Serializable;
import java.time.ZonedDateTime;
import java.util.Objects;

/**
 * A ServicesCompositionsVO.
 */
public class ServicesCompositionsVO implements Serializable {

    private static final long serialVersionUID = 1L;

    private Long id;
    private Long idservice;
    private Long idcomposition;
    private ZonedDateTime deleteddate;
    private String servicename;
    
    
    public ServicesCompositionsVO() {
    	id = null;
    	idservice = null;
    	idcomposition = null;
    	deleteddate = null;
    	servicename = null;
    }
    
    public ServicesCompositionsVO(Long id, Long idservice, Long idcomposition, ZonedDateTime deleteddate, String servicename) {
    	this.id = id;
    	this.idservice = idservice;
    	this.idcomposition = idcomposition;
    	this.deleteddate = deleteddate;
    	this.servicename = servicename;
    }
    

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    public Long getIdservice() {
        return idservice;
    }

    public void setIdservice(Long idservice) {
        this.idservice = idservice;
    }
    
    public Long getIdcomposition() {
        return idcomposition;
    }

    public void setIdcomposition(Long idcomposition) {
        this.idcomposition = idcomposition;
    }

    public ZonedDateTime getDeleteddate() {
        return deleteddate;
    }

    public ServicesCompositionsVO deleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
        return this;
    }

    public void setDeleteddate(ZonedDateTime deleteddate) {
        this.deleteddate = deleteddate;
    }
    
    public String getServicename() {
    	return servicename;
    }
    
    public void setServicename(String servicename) {
    	this.servicename = servicename;
    }
    

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ServicesCompositionsVO servicesCompositionsVO = (ServicesCompositionsVO) o;
        if (servicesCompositionsVO.getId() == null || getId() == null) {
            return false;
        }
        return Objects.equals(getId(), servicesCompositionsVO.getId());
    }

    @Override
    public int hashCode() {
        return Objects.hashCode(getId());
    }

    @Override
    public String toString() {
        return "ServicesCompositionsVO{" +
            "id=" + getId() +
            ", idservice='" + getIdservice() + "'" +
            ", idcomposition='" + getIdcomposition() + "'" +
            ", deleteddate='" + getDeleteddate() + "'" +
            ", servicename='" + getServicename() + "'" +
            "}";
    }
}
