/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
package eu.decideh2020.acsmi.backend.services.server.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import eu.decideh2020.acsmi.backend.services.server.domain.Service;
import eu.decideh2020.acsmi.backend.services.server.domain.vo.ServiceFilterVO;


/**
 * Spring Data JPA repository for the Service entity.
 */
@Repository
public interface ServiceRepository extends JpaRepository<Service,Long> {
	@Query("select new eu.decideh2020.acsmi.backend.services.server.domain.vo.ServiceFilterVO(s.id, s.servicename, v.id, v.serviceattributevalue, t.id, t.serviceattributetypename, t.enumerationvalues) from Service s join ServiceAttributeValue v on s.id = v.serviceid join ServiceAttributeType t on v.serviceattributetypeid = t.id where s.serviceclass.id = ?1")
	public List<ServiceFilterVO> filterQuery(Long classid);
	
	@Query("select new eu.decideh2020.acsmi.backend.services.server.domain.vo.ServiceFilterVO(s.id, s.servicename, v.id, v.serviceattributevalue, t.id, t.serviceattributetypename, t.enumerationvalues) from Service s join ServiceAttributeValue v on s.id = v.serviceid join ServiceAttributeType t on v.serviceattributetypeid = t.id where s.serviceclass.id = ?1 and t.id in (?2)")
	public List<ServiceFilterVO> filterQuery(Long classid, List<Long> attributetypeids);
	
	@Query("select s from Service s where s.id in (?1)")
	public List<Service> findByMultipleIds(List<Long> ids);
	
	public List<Service> findByServiceclass_id(Long classid);
	
}
