/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('RegisterController', RegisterController);


    RegisterController.$inject = ['$translate', '$timeout', 'Auth', 'LoginService'];

    function RegisterController ($translate, $timeout, Auth, LoginService) {
        var vm = this;

        vm.doNotMatch = null;
        vm.error = null;
        vm.errorUserExists = null;
        vm.login = LoginService.open;
        vm.register = register;
        vm.registerAccount = {};
        vm.success = null;

        $timeout(function (){angular.element('#firstName').focus();});

        function register () {
            if (vm.registerAccount.password !== vm.confirmPassword) {
                vm.doNotMatch = 'ERROR';
            } else {
                if(vm.settingsAccount.userType === "csp") {
                    vm.settingsAccount.contractReference = null;
                    vm.settingsAccount.creditCardType = null;
                    vm.settingsAccount.creditCard = null;
                } else if (vm.settingsAccount.userType === "pa" && vm.settingsAccount.creditOrContract === "contractreference") {
                    vm.settingsAccount.creditCardType = null;
                    vm.settingsAccount.creditCard = null;
                } else if (vm.settingsAccount.userType === "pa" && vm.settingsAccount.creditOrContract === "creditcard") {
                    vm.settingsAccount.contractReference = null;
                }
                vm.registerAccount = {
                    firstName: vm.registerAccount.firstName,
                    lastName: vm.registerAccount.lastName,
                    login: vm.registerAccount.login,
                    email: vm.registerAccount.email,
                    password: vm.registerAccount.password,
                    langKey: $translate.use(),
                    company: vm.settingsAccount.company,
                    usersGroup: vm.registerAccount.login,
                    userType: vm.settingsAccount.userType,
                    creditCardType: vm.settingsAccount.creditCardType,
                    creditCard: vm.settingsAccount.creditCard,
                    contractReference: vm.settingsAccount.contractReference,
                    cifOrVat: vm.settingsAccount.cifOrVat
                };
                vm.doNotMatch = null;
                vm.error = null;
                vm.errorUserExists = null;
                vm.errorEmailExists = null;
                vm.errorUsersGroupExists = null;
                Auth.createAccount(vm.registerAccount).then(function () {
                    vm.success = 'OK';
                }).catch(function (response) {
                    vm.success = null;
                    if (response.status === 400 && response.data === 'login already in use') {
                        vm.errorUserExists = 'ERROR';
                    } else if (response.status === 400 && response.data === 'email address already in use') {
                        vm.errorEmailExists = 'ERROR';
                    } else if (response.status === 400 && response.data === 'user group already exists') {
                        vm.errorUsersGroupExists = 'ERROR';
                    } else {
                        vm.error = 'ERROR';
                    }
                });
            }
        }
    }
})();
