/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('ServiceClassDialogController', ServiceClassDialogController);

    ServiceClassDialogController.$inject = ['$timeout', '$scope', '$translate', '$http', '$stateParams', '$uibModalInstance', 'entity', 'ServiceClass'];

    function ServiceClassDialogController ($timeout, $scope, $translate, $http, $stateParams, $uibModalInstance, entity, ServiceClass) {
        var vm = this;

        vm.serviceClass = entity;
        vm.clear = clear;
        vm.save = save;


        $timeout(function (){
            angular.element('.form-group:eq(1)>input').focus();
        });

        function clear () {
            $uibModalInstance.dismiss('cancel');
        }

        
        // Función de guardado de clase de servicio (alta o modificación)
        function save() {
            if (vm.serviceClass.id != null) {
                ServiceClass.update(vm.serviceClass, onSaveServiceClassSuccess, onSaveServiceClassError);
            } else {
            	vm.serviceClass.editable = true;
            	ServiceClass.save(vm.serviceClass, onSaveServiceClassSuccess, onSaveServiceClassError);
            }
        }

        
        // Función de éxito en alta/modificación de clase de servicio
        function onSaveServiceClassSuccess(result) {
        	$scope.$emit('acsmiApp:serviceClassUpdate', result);
            $uibModalInstance.close(result);
        }
        
        
        // Función de error en alta/modificación de clase de servicio
        function onSaveServiceClassError() {}
    }
})();
