/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('ServiceDeleteController',ServiceDeleteController);

    ServiceDeleteController.$inject = ['$uibModalInstance', 'entity', 'Service'];

    function ServiceDeleteController($uibModalInstance, entity, Service) {
        var vm = this;

        vm.service = entity;
        vm.clear = clear;
        vm.confirmDelete = confirmDelete;

        function clear () {
            $uibModalInstance.dismiss('cancel');
        }

        function confirmDelete(id) {
        	Service.delete({id: vm.service.id, forcedelete: 'true'}, onDeleteServiceSuccess, onDeleteServiceError);
        }
        
        
        // Función de éxito en borrado de servicio
        function onDeleteServiceSuccess() {
        	$uibModalInstance.close(true);
        }
        
        
        // Función de error en borrado de servicio
        function onDeleteServiceError() {
        	$uibModalInstance.close(true);
        }
    }
})();
