/*******************************************************************************
 * Copyright (c) 2017 Tecnalia.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 	
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * The code has been contributed over a stub generated with the JHipster
 * Application generator http://www.jhipster.tech/.
 * 
 * Contributors (in alphabetical order):
 * 
 * Gorka Benguria                       Tecnalia
 * Iñaki Etxaniz                        Tecnalia
 * Juncal Alonso                        Tecnalia
 * Leire Orue-Echevarria                Tecnalia
 * Maria Jose lopez                     Tecnalia
 * Marisa Escalante                     Tecnalia
 * 
 * Initially developed in the context of DECIDE EU project www.DECIDE-h2020.eu
 ******************************************************************************/
(function() {
    'use strict';

    angular
        .module('acsmiApp')
        .controller('ServiceDetailController', ServiceDetailController);

    ServiceDetailController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', 'previousState', 'entity', 'Service', 'ServiceAttributeType', 'ServiceAttributeValue'];

    function ServiceDetailController($scope, $rootScope, $state, $stateParams, previousState, entity, Service, ServiceAttributeType, ServiceAttributeValue) {
        var vm = this;

        vm.service = entity;
        vm.previousState = previousState.name;
        vm.nextState = vm.previousState;
        
        if (vm.previousState == 'contract') {
        	vm.nextState = 'contract';
        }  
        
        loadAttributes();
        
        // Función de carga de los atributos del servicio
        function loadAttributes() {
        	// Obtener valores de los atributos
        	vm.attributeValues = new Array();
        	ServiceAttributeValue.query(function(resultValues) {
        		if (resultValues != null && resultValues.length > 0) {
        			for (var i = 0;i < resultValues.length;i++) {
        				if (resultValues[i].serviceid == vm.service.id) {
        					vm.attributeValues.push(resultValues[i]);
        				}
        			}
        		}
        		
        		// Obtener tipos de atributos
        		vm.attributeTypes = new Array();
        		ServiceAttributeType.query(function(resultTypes) {
        			if (resultTypes != null && resultTypes.length > 0) {
        				vm.attributeTypes = resultTypes;
        			}
        			
        			// Cargar array de atributos definitivo
        			vm.attributes = new Array();
        			if (vm.attributeTypes != null && vm.attributeTypes.length > 0 && vm.attributeValues != null && vm.attributeValues.length > 0) {
        				for (var i = 0;i < vm.attributeValues.length;i++) {
        					for (var j = 0;j < vm.attributeTypes.length;j++) {
            					if (vm.attributeValues[i].serviceattributetypeid == vm.attributeTypes[j].id) {
            						var attrValue = vm.attributeValues[i].serviceattributevalue;
            						if (vm.attributeTypes[j].mandatoryenumeration) {
            							var obj = JSON.parse(vm.attributeTypes[j].enumerationvalues);
            							attrValue = obj[attrValue];
            						}
            						vm.attribute = {
            	        				name: vm.attributeTypes[j].serviceattributetypename,
            	        				value: attrValue
            	        			};
            						vm.attributes.push(vm.attribute);
            						break;
            					}
            				}
        				}
        			}
        		});
        	});
        }
        
        var unsubscribe = $rootScope.$on('acsmiApp:serviceUpdate', function(event, result) {
            vm.service = result;
            
            
        });
        $scope.$on('$destroy', unsubscribe);
    }
})();
